# -*- coding: utf-8 -*-

'''
@author: Dmitry Dvoeglazov
'''

from __future__ import unicode_literals
import logging

from django.apps import AppConfig

from version import __version__

class TermideskAppConfig(AppConfig):
    '''
    Termidesk django app config
    '''
    name = 'termidesk'
    label = 'termidesk'
    verbose_name = 'Termidesk'

    def ready(self):
        logger = logging.getLogger(__name__)
        logger.debug('Termidesk app ready')
        
        from . import services
        from . import transports
        from . import auths
        from . import rest
        
        from . import patch
        
        patch.patch_themes()
        patch.patch_default_images()

default_app_config = 'termidesk.TermideskAppConfig'
