# -*- coding: utf-8 -*-
from django.conf.urls import url
from . import views

from . import cbviews

urlpatterns = [
    url(r'^$', views.index, name="index"),
    url(r'^service-providers$', views.service_providers, name="providers"),
    url(r'^service-providers/(?P<provider_id>[a-zA-Z0-9_-]*)$', views.service_provider_info, name="provider"),
    url(r'^auth-domains$', views.auth_domains, name="auth_domains"),
    url(r'^auth-domains/(?P<domain_id>[a-zA-Z0-9_-]*)$', views.auth_domain_info, name="auth_domain"),
    url(r'^auth-domains/(?P<domain_id>[a-zA-Z0-9_-]*)/users/(?P<user_id>[a-zA-Z0-9_-]*)$', views.auth_domain_user_info, name="auth_domain_user"),
    url(r'^auth-domains/(?P<domain_id>[a-zA-Z0-9_-]*)/groups/(?P<group_id>[a-zA-Z0-9_-]*)$', views.auth_domain_group_info, name="auth_domain_group"),
    url(r'^os-managers$', views.os_managers, name="os_managers"),
    url(r'^delivery-protocols$', views.delivery_protocols, name="delivery_protocols"),
    url(r'^components/networks$', views.networks, name="networks"),
    url(r'^settings/gallery$', views.settings_gallery, name="settings_gallery"),
    url(r'^settings/spgs$', views.settings_service_pool_groups, name="settings_spgs"),
    url(r'^settings/sysconfig$', views.settings_sysconfig, name="settings_sysconfig"),
    url(r'^settings/license$', cbviews.LicenseUpload.as_view(), name="settings_license"),
    url(r'^workplaces$', views.workplaces, name="workplaces"),
    url(r'^workplaces/(?P<workplace_id>[a-zA-Z0-9_-]*)$', views.workplace_info, name="workplace_info"),
    url(r'^workplaces/(?P<workplace_id>[a-zA-Z0-9_-]*)/as/(?P<service_id>[a-zA-Z0-9_-]*)$', views.workplace_as_info, name="workplace_as_info"),
    url(r'^workplaces/(?P<workplace_id>[a-zA-Z0-9_-]*)/cs/(?P<service_id>[a-zA-Z0-9_-]*)$', views.workplace_cs_info, name="workplace_cs_info"),
    url(r'^monitoring$', views.monitoring, name="monitoring"),
    url(r'^tmpl/(?P<template>[a-zA-Z0-9_-]*)$', views.tmpl, name="tmpl"),
]