# -*- coding: utf-8 -*-

'''
@author: dvd
'''

def __init__():
    '''
    This imports all packages that are descendant of this package, and, after that,
    it register all subclases of Handler. (In fact, it looks for packages inside "methods" package, child of this)
    '''
    import os.path
    import pkgutil
    import sys

    import logging
    from importlib import import_module
    from uds.REST import Dispatcher
    from uds.REST.handlers import Handler, HandlerError, AccessDenied, NotFound, RequestError, ResponseError, NotSupportedError
    
    logger = logging.getLogger(__name__)
    logger.debug('Loading Handlers')

    package = 'methods'

    pkgpath = os.path.join(os.path.dirname(sys.modules[__name__].__file__), package)
    for _, name, _ in pkgutil.iter_modules([pkgpath]):
        import_module('.{}.{}'.format(package, name), __package__)
        logger.debug("Imported {} module from {}".format(name, __package__))

    Dispatcher.registerSubclasses(Handler.__subclasses__())  # @UndefinedVariable
        
__init__()
del __init__