# -*- coding: utf-8 -*-
'''
Created on Nov 8, 2019

@author: dvd
'''
from __future__ import unicode_literals

from django.utils.translation import ugettext_lazy as _
from uds.core import services
from uds.core.services import types as serviceTypes
from uds.core.ui.UserInterface import gui
from .OVirtStaticDeployment import OVirtStaticDeployment
import logging


logger = logging.getLogger(__name__)


class OVirtStaticService(services.Service):

    # Gui
    vmId = gui.TextField(length=64, label=_('Идентификатор ВМ'), order=1, tooltip=_('Уникальный идентификатор ВМ'), required=True)

    typeName = _('Статичная ВМ oVirt/RHEV')
    typeType = 'OVirtStaticService'
    typeDescription = _('Предоставляет доступ к статичным включенным ВМ по Spice протоколу')
    iconFile = 'service.png'

    maxDeployed = -1  # If the service provides more than 1 "provided service" (-1 = no limit, 0 = ???? (do not use it!!!), N = max number to deploy
    usesCache = False  # Cache are running machine awaiting to be assigned
    usesCache_L2 = False  # L2 Cache are running machines in suspended state
    needsManager = False  # If the service needs a s.o. manager (managers are related to agents provided by services itselfs, i.e. virtual machines with agent)
    mustAssignManually = False  # If true, the system can't do an automatic assignation of a deployed user service from this service

    deployedType = OVirtStaticDeployment

    servicesTypeProvided = (serviceTypes.VDI,)

    def initialize(self, values):
        pass
    
    def getConsoleConnection(self, machineId):
        return self.parent().getConsoleConnection(machineId)
    
    def getHostname(self):
        return self.parent().host.value