(function() {
"use strict";
	
	var termidesk = this.termidesk;
	termidesk.utils = termidesk.utils != null ? termidesk.utils : {};
	
	const utils = termidesk.utils
	
	utils.throttle = function(fn, interval) {
    	let isThrottled = false;
    	
    	const wrapper = function() {
    		let fnArgs = null;
    		let fnThis = null;
    		
    		if (isThrottled) {
		      fnArgs = arguments;
		      fnThis = this;
		      return;
		    }

		    fn.apply(this, arguments);

		    isThrottled = true;

		    setTimeout( function() {
		      isThrottled = false;
		      //console.log(`Cleared throttling`)
		    }, interval);
    	}
    	
    	return wrapper;
    }
    
	utils.updateDict = function (oldDict, newDict) {
	    for (var attrname in oldDict) { oldDict[attrname] = newDict[attrname]; }
	}
	
}).call(this);