# -*- coding: utf-8 -*-
from django.conf.urls import include, url
from uds.urls import urlpatterns as uds_urls
from . import views
from .admin2 import urls as admin2_urls
from .web.views.workplace import connectionEnabler
from .web.views.html5spice import index as h5spice

from pkg_resources import iter_entry_points

urlpatterns = [
    #url(r'^test-view/', views.test_view),
    #url(r'^test-view/', views.test_view),
    #url(r'^adm/', include(admin_urls)),
    url(r'^admin/', include(admin2_urls, namespace='admin2')),
    # Client access enabler
    url(r'^enable/(?P<idService>.+)/(?P<idTransport>.+)$', connectionEnabler, name='ClientAccessEnabler'),
    url(r'^clients/html5spice/(?P<ticketId>.+)$', h5spice, name='Html5SpiceClient'),
    url(r'^', include(uds_urls)),
]

for entry_point in iter_entry_points('termidesk.apps'):
    app_config = entry_point.load()
    urlpatterns.append(url(r'^', include('{}.urls'.format(app_config.name))))