# This is a template
# Saved as .py for easier editing
from __future__ import unicode_literals

# pylint: disable=import-error, no-name-in-module, undefined-variable
import subprocess

from client import tools  # @UnresolvedImport
from client.wstunnel import wstunnel # @UnresolvedImport

executable = tools.findApp('remote-viewer')

if executable is None:
    raise Exception('''<p>You need to have installed virt-viewer to connect to this VDI service.</p>
<p>
    Please, install appropriate package for your system.
</p>
<p>
    Please, install appropriate package for your Linux system. (probably named something like <b>virt-viewer</b>)
</p>
''')


if {m.port} != -1:  # @UndefinedVariable
    forwardThread1, port = wstunnel('{m.tun_url}', {m.port}, timeout={m.tun_lifetime})  # @UndefinedVariable

    if forwardThread1.status == 2:
        raise Exception('Unable to open tunnel')
else:
    port = -1

if {m.secure_port} != -1:  # @UndefinedVariable
    forwardThread2, secure_port = wstunnel('{m.tun_secure_url}', {m.secure_port}, timeout={m.tun_lifetime})  # @UndefinedVariable

    if forwardThread2.status == 2:
        raise Exception('Unable to open tunnel')
else:
    secure_port = -1

theFile = '''{m.r.as_file}'''.format(
    secure_port=secure_port,
    port=port
)

filename = tools.saveTempFile(theFile)


subprocess.Popen([executable, filename])
